﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Bottle : MonoBehaviour {

    public GameObject brokenBottle;
    public SpriteRenderer bottleGraphics;
    public GameObject splashEffect;
    private FloatableObj floatable;
    public GameObject deathDropDownMenu;
    public bool IsAlive {  get { return bottleGraphics.enabled; } }
    public AudioClip breakingBottle;

    public bool canDie = true;

    public void Start()
    {
        floatable = GetComponent<FloatableObj>();
        floatable.OnHitWater += OnHitWater;
    }

    public void Update()
    {
        if(floatable.UnderWater)
        {
            if (floatable.WaterDiff > 1.0f)
                return;
        }
    }
    private void DeactivateSplash()
    {
        splashEffect.SetActive(false);
    }
    private void OnHitWater(float speed)
    {
        if(speed < -5.0f && bottleGraphics.enabled)
        {
            splashEffect.transform.position = transform.position +Vector3.up*0.91f;
            splashEffect.SetActive(true);
            Invoke("DeactivateSplash", 0.444f);
        }
    }

    public void OnTriggerEnter2D(Collider2D collision)
    {
        if(collision.CompareTag("Necklace"))
        {
            Destroy(collision.gameObject);
            return;
            //AudioSource.PlayClipAtPoint(waterSplash, Vector2.zero);
        }
        if (!canDie || !bottleGraphics.enabled)
            return;
        bottleGraphics.enabled = false;
        brokenBottle.SetActive(true);
        deathDropDownMenu.SetActive(true);
        GetComponent<AudioSource>().PlayOneShot(breakingBottle, 1.0f);
    }
}
