﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class BottleTracker : MonoBehaviour {
    public RectTransform start;
    public RectTransform end;
    public float currentLevelTime = 0.0f;
    public float totalLevelTime = 100.0f;
    public Image goPopup;
    public Image bottlePopup;
    public Image deliveredPopup;
    public Interactions interactions;
    public Transform islandGraphics;
    public Bottle bottle;
    public string nextScene;
    public AudioClip whipSound;
    public Vector2 position {  get { return Vector2.Lerp(start.position, end.position, currentLevelTime / totalLevelTime); } }
    public void Start()
    {
        interactions = FindObjectOfType<Interactions>();
        interactions.enabled = false;
        Time.timeScale = 0.0f;
        bottle = FindObjectOfType<Bottle>();
        islandGraphics.transform.position = Vector3.right * (33  + (5 * totalLevelTime));
    }
    //public void OnDrawGizmos()
    //{
    //    islandGraphics.transform.position = Vector3.right * (33 + (5 * totalLevelTime));
    //}
    private IEnumerator FadeGo()
    {
        GetComponent<AudioSource>().PlayOneShot(whipSound);
        Time.timeScale = 1.0f;
        interactions.enabled = true;
        var rect = goPopup.GetComponent<RectTransform>();
        float timer = 0.0f;
        while(timer < 1.0f)
        {
            timer += Time.deltaTime*3.0f;
            rect.sizeDelta = Vector2.Lerp(Vector2.one * 300, Vector2.zero, timer);
            yield return null;
        }
        goPopup.enabled = false;
    }

    // Update is called once per frame
    void Update ()
    {
        if (islandGraphics.transform.position.x < 33.0f)
            islandGraphics.transform.position = new Vector3(33.0f, 0.0f, 0.0f);
        if (Input.GetKeyDown(KeyCode.Mouse0) && Time.timeScale == 0.0f && goPopup.enabled)
            StartCoroutine(FadeGo());
        transform.position = position;
        if(bottle.IsAlive)
        {
            islandGraphics.transform.position -= 5.0f * Vector3.right * Time.deltaTime;
            currentLevelTime += Time.deltaTime;
            if (currentLevelTime > totalLevelTime && !deliveredPopup.enabled && !bottlePopup.enabled)
            {
                StartCoroutine(ShowDelivered());
            }
        }
	}

    private IEnumerator ShowDelivered()
    {
        bottlePopup.enabled = true;
        float timer = 0.0f;
        while (timer <= 1.0f)
        {
            timer += Time.deltaTime;
            bottlePopup.transform.localScale = Vector2.Lerp(Vector2.zero, Vector2.one, timer);
            yield return null;
        }
        timer = 0.0f;
        deliveredPopup.enabled = true;
        var rect = deliveredPopup.GetComponent<RectTransform>();
        while (timer <= 1.0f)
        {
            timer += Time.deltaTime;
            rect.sizeDelta = Vector2.Lerp(Vector2.zero, Vector2.one * 300, timer);
            yield return null;
        }
        yield return new WaitForSeconds(3.0f);
        SceneManager.LoadScene(nextScene);
    }
}
