﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.SceneManagement;

public class ButtonBounce : MonoBehaviour, IPointerEnterHandler, IPointerClickHandler
{
    public Animator menuAnimator;
    public Vector3 originalPos;
    public float sensitivity = 10.0f;
    public float decay;
    public AudioClip mouseOverSound;
    public AudioClip mouseClickSound;

    public void Start()
    {
        originalPos = transform.localPosition;
    }
    public void Update()
    {
        transform.localPosition = Vector3.Slerp(transform.localPosition, originalPos, Time.deltaTime*decay);
    }
    public void OnPointerEnter(PointerEventData eventData)
    {
        transform.localPosition += (Vector3)eventData.delta.normalized * sensitivity;
        GetComponent<AudioSource>().PlayOneShot(mouseOverSound);
    }
    public void OnPointerClick(PointerEventData eventData)
    {
        if(menuAnimator != null)
            menuAnimator.Play("HideMenu");
        GetComponent<AudioSource>().PlayOneShot(mouseClickSound);
    }
    public void LoadTutorial()
    {
        SceneManager.LoadScene("Tutorial");
    }
    public void ReloadLevel()
    {
        SceneManager.LoadScene(SceneManager.GetActiveScene().name);
    }
}
