﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MoveWaveOffset : MonoBehaviour {

    public float normalizedOffsetSpeed = -1.0f;
    public float offsetSpeed = -1.0f;
    public float amplitudeDecay = 0.99f;
    private Wave wave;

    public void Start()
    {
        wave = GetComponent<Wave>();
    }
    public void Update()
    {
        wave.normalizedWaveOffset += normalizedOffsetSpeed * Time.deltaTime;
        wave.waveOffset += offsetSpeed * Time.deltaTime;
        wave.amplitude *= amplitudeDecay;
        if (Mathf.Abs(wave.amplitude) < 0.1f)
            Destroy(gameObject);
    }
}
