﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WavesSum : MonoBehaviour{

    public Wave primaryWave;
    public List<Wave> waves = new List<Wave>();
    public Material wavesMaterial;

    public float Eval(float worldX, bool useSecondary = true)
    {
        float y = primaryWave.WorldEval(worldX);
        if(useSecondary)
            foreach (var wave in waves)
                y += wave.WorldEval(worldX);
        return y;
    }
    private void OnDrawGizmos()
    {
        //Ocean Line
        Gizmos.color = Color.red;
        Gizmos.DrawLine(-Vector2.right * 0.0f, Vector2.right * 20.0f);

        Gizmos.color = Color.cyan;
        //Wave
        int segments = 150;
        Vector2 last = Vector2.zero;
        for (int i = 0; i <= segments; i++)
        {
            float x = (i / (float)segments) *20.0f;
            Vector2 next = new Vector2(x, Eval(x));
            Gizmos.DrawLine(last, next);
            last = next;
        }
        Gizmos.color = Color.white;
        Gizmos.matrix = Matrix4x4.identity;
    }
    public Wave toTrack;
    public void Update()
    {
        if(toTrack != null)
            wavesMaterial.SetVector("_Wave2Params", new Vector4(toTrack.normalizedWaveOffset, toTrack.amplitude, toTrack.normalizedWaveLength));
        else
            wavesMaterial.SetVector("_Wave2Params",Vector4.zero);
    }
    public void SetSecondary(Wave wave)
    {
        toTrack = wave;}
}
